/***************************************************************************
	eXynth GUI library
	(C) 2010 Anti Sullin / Artec Design <anti.sullin@artecdesign.ee>

	Based on xynth library:
    (C) 2003 - 2008 by Alper Akcan <distchx@yahoo.com>
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Lesser General Public License as        *
 *   published by the Free Software Foundation; either version 2.1 of the  *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#include <stdlib.h>

#include "exynth.h"
#include "image.h"

//#define DEBUG
#include "debug.h"

int s_image_init (s_image_t **img)
{
	(*img) = (s_image_t *) calloc(1, sizeof(s_image_t));
	return 0;
}

void s_image_free_rgba (s_image_t *img)
{
	if (img->rgba == NULL) return;
	free(img->rgba);
	img->rgba = NULL;
}

int s_image_uninit (s_image_t *img)
{
	if (img == NULL) {
		return 0;
	}
	s_image_free_rgba(img);
	free(img);
	img = NULL;
	return 0;
}


int s_image_img (const char *file, s_image_t *img)
{
	if (!s_image_png_is(file)) {
		return s_image_png(file, img);
	}
	debug("Unknown image format (%s)", file);
	return -1;
}
