/***************************************************************************
	eXynth GUI library
	(C) 2010 Anti Sullin / Artec Design <anti.sullin@artecdesign.ee>

	Based on xynth library:
    (C) 2003 - 2008 by Alper Akcan <distchx@yahoo.com>
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Lesser General Public License as        *
 *   published by the Free Software Foundation; either version 2.1 of the  *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#include "../exynth.h"

// id's 1...255 are for windows
// id 0 is blank

/* Get the first free id */
int s_server_id_alloc (void)
{
	s_exynth_t *e = get_exynth();
	int i;
	for (i = 1; i < S_CLIENTS_MAX; i++) {
		if (e->clients[i] == NULL) {
			return i;
		}
	}
	return -1;
}

/* Find the window id in the map */
int s_server_id_find (void *wnd)
{
	s_exynth_t *e = get_exynth();
	int i;
	for (i = 0; i < S_CLIENTS_MAX; i++) {
		if (e->clients[i] == wnd) {
			return i;
		}
	}
	return -1;
}

/* Release the window id in map */
void s_server_id_free (int id)
{
	s_exynth_t *e = get_exynth();
	if (id<0 || id>S_CLIENTS_MAX) return;
	e->clients[id] = NULL;
}
