/***************************************************************************
	eXynth GUI library
	(C) 2010 Anti Sullin / Artec Design <anti.sullin@artecdesign.ee>

	Based on xynth library:
    (C) 2003 - 2008 by Alper Akcan <distchx@yahoo.com>
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Lesser General Public License as        *
 *   published by the Free Software Foundation; either version 2.1 of the  *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef SERVER_H_
#define SERVER_H_

#if defined(__cplusplus)
	extern "C" {
#endif

int s_server_id_alloc (void);
int s_server_id_find (void *wnd);
void s_server_id_free (int id);

void s_server_surface_matrix_find (s_rect_t *coor, unsigned char *dm);
void s_server_surface_matrix_add_id (int id, s_rect_t *coor);
void s_server_surface_matrix_add (int id, s_rect_t *coor);
void s_server_surface_matrix_del_coor (s_rect_t *coor);

int s_server_pri_arr_focus(int id);
void s_server_update_top_pri();
void s_server_pri_arr_del(int id);
void s_server_pri_focus_prepare(int id);
void s_server_pri_focus(int id);
void s_server_pri_move(int id, s_rect_t *old);
void s_server_pri_del(int id);
void s_server_pri_update(s_rect_t *rect);
void s_server_pri_recalc_list(s_rect_t *rect);
void s_server_pri_expose(s_rect_t *rect);
void s_server_pri_notify();

#if defined(__cplusplus)
	}
#endif

#endif /* SERVER_H_ */
