/***************************************************************************
	eXynth GUI library
	(C) 2010 Anti Sullin / Artec Design <anti.sullin@artecdesign.ee>

	Based on xynth library:
    (C) 2003 - 2008 by Alper Akcan <distchx@yahoo.com>
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Lesser General Public License as        *
 *   published by the Free Software Foundation; either version 2.1 of the  *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef TIMER_H_
#define TIMER_H_

typedef struct s_timer_s s_timer_t;

#include "window.h"

#if defined(__cplusplus)
	extern "C" {
#endif

struct s_timer_s {
	/** timer value in microseconds */
	long long timeval;
	/** remaining timer value in microseconds,
	    if this is <= 0 then it is time to call the callback */
	long long interval;
	/** time when the timer was started */
	long long startval;
	/** call back function; if NULL, call back window event handler */
	void (*cb) (s_window_t *, s_timer_t *);
	/** pointer to hold user specified data */
	void *data;
	/** window to which this timer belongs to */
	s_window_t *window;
};

int s_timers_init (void);
int s_timers_uninit (void);

int s_timer_init (s_timer_t **timer);
int s_timer_uninit (s_timer_t *timer);
int s_timer_del (s_timer_t *timer);
int s_timer_del_wnd (void *window);
int s_timer_add (s_timer_t *timer);
int s_timer_next_wakeup (void);
void s_timer_handle(long long start, long long stop);

long long s_gettimeofday (void);

#if defined(__cplusplus)
	}
#endif

#endif /* TIMER_H_ */
