/*
 * GuiLibrary.h
 *
 *  Created on: Mar 31, 2009
 *      Author: andrei
 */

#ifndef GUILIBRARY_H_
#define GUILIBRARY_H_

#include <stddef.h>

/**
 * \brief GUI helper class
 *
 * Implements basic application-wide methods
 *
 * \author Anti Sullin, Andrei Birjukov
 */
class GuiLibrary
{
public:

	static bool initialize();
	static bool shutdown();

	static bool lock();
	static bool timedlock(int ms);
	static bool unlock();

	static void broadcastSystemEvent(int code, void* data);
	static void broadcastUserEvent(int code, void* data);

	static size_t utf8strlen(const char *text);
	static size_t utf8pos2pos(const char *text, size_t n);
};

#endif /* GUILIBRARY_H_ */
