/*
 * BluetoothPort.cpp
 *
 *  Created on: 21.06.2011
 *      Author: ivari
 */

#include <string.h>
#include <stdio.h>

#include "BluetoothPort.h"

//#define DEBUG
//#define DEBUG_BYTES
#include "Debug.h"


BluetoothPort::BluetoothPort() {
	btReader = NULL;
}

BluetoothPort::~BluetoothPort() {
	if(btReader != NULL) delete btReader;
}

ssize_t BluetoothPort::write(const char *pData, size_t len) {

#ifdef DEBUG_BYTES
	for(size_t i=0; i<len; i++) {
		debug("Write byte %d %c %x\n",i, pData[i], pData[i]);
	}
#endif

	return writeData((uint8_t*) pData, len);
}

bool BluetoothPort::initReader(BluetoothModule *btModule){
	if(btReader == NULL) {
		btReader = new BluetoothReader(btModule);
	}

	return true;
}

void BluetoothPort::startRead() {
	btReader->pollSem.post();
}



BluetoothReader::BluetoothReader(BluetoothModule *btModule) {
	this->btModule = btModule;
	start();
}

BluetoothReader::~BluetoothReader() {
	requestStop();
	pollSem.post();
	stop();
}

void BluetoothReader::run() {
	debug("Starting data dispatcher thread...\n");

	while(!stopRequested()) {
		btModule->pollIncomingData(250);
		pollSem.pend();
	}

	debug("Stopping data dispatcher\n");
}

