/*
 * BluetoothSocket.h
 *
 *  Created on: 29.06.2011
 *      Author: ivari
 */

#ifndef BLUETOOTHSOCKET_H_
#define BLUETOOTHSOCKET_H_

#include "BluetoothSPPConnection.h"
#include "BluetoothConnection.h"
#include "Socket.h"

class BluetoothSocket : public Socket {

public:
	BluetoothSocket(BluetoothConnection *btConn);
	~BluetoothSocket();
	bool connect(const unsigned char *dstAddr, int dstPort = 0, const char *pin = NULL);
	bool connect(const char* host, int port);
	bool close();

	size_t readData(unsigned char* pData, size_t maxLen);
	bool writeData(unsigned char *pData, size_t dataLen);

	size_t getPendingInput();

	bool setTimeouts(int sendTout, int recvTout);
	bool setKeepalive(int keepIdle, int keepInterval, int keepCount);

	bool isConnected();

private:
	BluetoothSPPConnection *spp;
	BluetoothConnection *bt;

	int keepAliveCount;

};

#endif /* BLUETOOTHSOCKET_H_ */
