/*
 * Socket.h
 *
 *  Created on: 02.08.2011
 *      Author: ivari
 */

#ifndef SOCKET_H_
#define SOCKET_H_

class Socket {

public:
	virtual bool connect(const char* host, int port) = 0;
	virtual bool close() = 0;

	virtual bool writeData(unsigned char *pData, size_t dataLen) = 0;
	virtual size_t readData(unsigned char* pData, size_t maxLen) = 0;

	virtual size_t getPendingInput() = 0;

	virtual bool setTimeouts(int sendTout, int recvTout) = 0;
	virtual bool setKeepalive(int keepIdle, int keepInterval, int keepCount) = 0;

	virtual bool isConnected() = 0;
};

#endif /* SOCKET_H_ */
