//--------------------------------------------------------------------------------
//EPC Commands
#define EPC_CMD_QUERYREP      0x00 // queryrep
#define EPC_CMD_ACK           0x01 // acknowldege
#define EPC_CMD_QUERY         0x08 // query
#define EPC_CMD_QUERYADJUST   0x09 // query adjust
#define EPC_CMD_SELECT        0x0A // select
#define EPC_CMD_NAK           0xC0 // not acknowldege
#define EPC_CMD_REQRN         0xC1 // request new RN16 or handle
#define EPC_CMD_READ          0xC2 // read
#define EPC_CMD_WRITE         0xC3 // write
#define EPC_CMD_KILL          0xC4 // kill
#define EPC_CMD_LOCK          0xC5 // lock
#define EPC_CMD_ACCESS        0xC6 // access
#define EPC_CMD_BLOCKWRITE    0xC7 // blockwrite
#define EPC_CMD_BLOCKERASE    0xC8 // blockerase

// EPC SELECT TARGET
#define EPC_TARGET_INV_S0		0x00 // 000: Inventoried (S0)
#define EPC_TARGET_INV_S1		0x01 // 001: Inventoried (S1)
#define EPC_TARGET_INV_S2		0x02 // 010: Inventoried (S2)
#define EPC_TARGET_INV_S3		0x03 // 011: Inventoried (S3)
#define EPC_TARGET_INV_SL		0x04 // 100: SL

// EPC Mem Banks
#define EPC_MEM_RES				0x00
#define EPC_MEM_EPC				0x01
#define EPC_MEM_TID				0x02
#define EPC_MEM_USER			0x03

void ams_epc_ack_async(void *context);
void ams_epc_reqrn_async(void *context);
