/* include/linux/rfid_nxp.h
 *
 * Copyright (c) 2007 Artec Design LLC
 *   Jaanus Sepp <jaanus.sepp@artecdesign.ee>
 *
 * Header file for NXP RFID Reader platform data
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
*/

#ifndef __RFID_NXP_PLATFORM_DATA
#define __RFID_NXP_PLATFORM_DATA __FILE__

enum enum_rfid_nxp_pins {
  RFID_NXP_PIN_PWRDWN,
  RFID_NXP_PIN_PWR_N,
  RFID_NXP_PINCOUNT
};

struct rfid_nxp_plat_data {
  unsigned int pin_assignment[RFID_NXP_PINCOUNT];
  unsigned int irq; // currently not used!
};

// ioctl definitions
#define RFID_NXP_STOP_READ				0xef01
#define RFID_NXP_SET_PROTOCOLS			0xef02
#define RFID_NXP_SET_BLOCK_ON			0xef03
#define RFID_NXP_SET_BLOCK_OFF			0xef04
#define RFID_NXP_SET_ALL_BLOCKS_ON		0xef05
#define RFID_NXP_SET_ALL_BLOCKS_OFF		0xef06

// protocol defines

#define RFID_NXP_PROTOCOL_ISO15693		0
#define RFID_NXP_PROTOCOL_ISO14443A		1
#define RFID_NXP_PROTOCOL_ISO14443B		2

struct rfid_nxp_hdr {
	unsigned char ret;
	unsigned char idLen;
	unsigned short dataLen;
} __attribute__((packed));


#endif /* __RFID_NXP_PLATFORM_DATA */

